/**
 * Indicates if lobby dialog is opened.
 */
var g_LobbyDialogOpened = false;

/**
 * Function name for call when notification happens in lobby.
 */
var g_UpdateLobbyNotification = notify => {};

/**
 * Notification sign used in menus.
 */
var g_NofiticationSign = "*";

var g_Nick = Engine.LobbyGetNick();

var g_LobbyChat = [];

var g_LobbyTextGui = Engine.GetGUIObjectByName("lobbyText");


function addT(msg)
{
    return;
    if (!g_LobbyTextGui)
        return;
        
    g_LobbyTextGui.caption += (g_LobbyTextGui.caption ? "\n" : "") +
        (msg.level == "private-message" || msg.private ? setStringTags("(Private) ", { "color": "yellow" }) : "" ) +
        setStringTags("<" + (msg.from || msg.nick) + "> ", { "font": "sans-bold-stroke-13" }) + (msg.text ? msg.text.replace(g_Nick, setStringTags(g_Nick, { "color": "yellow"})) : msg.reason);
}

/**
 * Executes a lobby command or sends GUI input directly as chat.
 */
function submitLobbyChatInput(input)
{
	// let input = Engine.GetGUIObjectByName("chatInput");
	let text = input.caption;

	if (!text.length)
		return;

	// if (handleChatCommand(text))
		Engine.LobbySendMessage(text);

	input.caption = "";
}

/**
 * Lobby net messages, that triggers a notification.
 */
var g_LobbyNetMessageTypeNotification = {
	"system": {
        "disconnected": msg => { //warn("system disconnected"); 
        return true }
	},
	"chat": {
        // "subject": msg => true,
        "role": msg => { return msg.nick == g_Nick},
        "room-message": msg => { addT(msg); return msg.text.toLowerCase().search(matchPlayerName(g_Nick.toLowerCase())) != -1},
        "kicked": msg => { addT(msg); return msg.nick == g_Nick},
        "banned": msg => { addT(msg); return msg.nick == g_Nick},
        "private-message": msg => { addT(msg); return true }
	}
};

function handleNetLobbyMessagesInBackground()
{
    if (!g_LobbyDialogOpened)
    {
        let msg = Engine.LobbyGuiPollNewMessage(); // Only poll new messages no historic.

        if (!msg)
            return;

        if ( g_LobbyNetMessageTypeNotification[msg.type] &&
            g_LobbyNetMessageTypeNotification[msg.type][msg.level] &&
            g_LobbyNetMessageTypeNotification[msg.type][msg.level](msg))
        {
            warn(uneval(msg))
            g_UpdateLobbyNotification(true);
            soundNotification("nick");
        }
    }
}

function setLobbyDialogClosed()
{
    g_LobbyDialogOpened = false;
}
