/**
 * Used for checking replay compatibility.
 */
const g_EngineInfo = Engine.GetEngineInfo();

/**
 * Needed for formatPlayerInfo to show the player civs in the details.
 */
const g_CivData = loadCivData(false, false);

/**
 * Used for creating the mapsize filter.
 */
const g_MapSizes = prepareForDropdown(g_Settings && g_Settings.MapSizes);

/**
 * All replays found in the directory.
 */
var g_Replays = [];

/**
 * List of replays after applying the display filter.
 */
var g_ReplaysFiltered = [];

/**
 * Array of unique usernames of all replays. Used for autocompleting usernames.
 */
var g_Playernames = [];

/**
 * Sorted list of unique maptitles. Used by mapfilter.
 */
var g_MapNames = [];

/**
 * Sorted list of the victory conditions occuring in the replays
 */
var g_VictoryConditions = g_Settings && g_Settings.VictoryConditions;

/**
 * Directory name of the currently selected replay. Used to restore the selection after changing filters.
 */
var g_SelectedReplayDirectory = "";

/**
 * Skip duplicate expensive GUI updates before init is complete.
 */
var g_ReplaysLoaded = false;

/**
 * Remember last viewed summary panel and charts.
 */
var g_SummarySelectedData;

/**
 * Set list column sort.
 */
var g_ColumnOrder = [];

var g_InGame = false;
var g_Dialog = false;

/**
 * Initializes globals, loads replays and displays the list.
 */
function init(data)
{
	if (!g_Settings)
	{
		Engine.SwitchGuiPage("page_pregame.xml");
		return;
	}

	g_InGame = data && !!data.ingame;
	g_Dialog = data && !!data.dialog;

	g_ColumnOrder = initGUIListSort("replaySelection", "replay.sort");
	loadReplays(data && data.replaySelectionData || null, false);
	// wonsLost();

	if (!g_Replays)
	{
		Engine.SwitchGuiPage("page_pregame.xml");
		return;
	}

	initGUIWindow();
	Engine.GetGUIObjectByName("summaryButton").tooltip =
	colorizeHotkey("Hit %(hotkey)s for toggle summary", "summary");

	initHotkeyTooltips();
	displayReplayList();
	// forumButtonGlow(false);
	// g_Glow = setTimeout(() => forumButtonGlow(true), 1000);

	if (data && data.summarySelectedData)
		g_SummarySelectedData = data.summarySelectedData;
	
	if (data && !!data.showNextSummary)
		showSummary(data.showNextSummary);
	
	forumButton();
	return
	
	Engine.GetGUIObjectByName("replaySelection").selected = 6;

	for (let j of [1,2])
	warn(j)

	const combi = combi => {
		let combis = [];

		if (combi.length == 2)
			return [[combi[0],combi[1]], [combi[1],combi[0]]];
		
		for (let el in combi)
			for(let pos in combi)
				combis.push(combi())
	}

	warn(uneval(combi([1,2])));
	return;


	for (let i=0; i<g_ReplaysFiltered.length; ++i)
		metaData(i);
		
	for (let rank in g_Ranks)
	{
		g_Ranks[rank].scoreRatio = Math.round(g_Ranks[rank].scoreSum/g_Ranks[rank].gameNum);
		g_Ranks[rank].scorePerTimeRatio = Math.round(g_Ranks[rank].scorePerTimeSum/g_Ranks[rank].gameNum);
		g_Ranks[rank].timeLastKillRatio = Math.round(g_Ranks[rank].timeLastKillSum/g_Ranks[rank].gameNum);
		g_Ranks[rank].gameTimeRatio = Math.round(g_Ranks[rank].gameTimeSum/g_Ranks[rank].gameNum);
	}
	
	

	// for (let rank of Object.keys(g_Ranks).sort((a,b) => g_Ranks[a].scorePerTimeRatio < g_Ranks[b].scorePerTimeRatio))
	// 	println([rank, g_Ranks[rank].scoreSum, g_Ranks[rank].scorePerTimeSum, g_Ranks[rank].scoreRatio, g_Ranks[rank].scorePerTimeRatio, g_Ranks[rank].timeLastKillRatio, g_Ranks[rank].gameTimeRatio].join(" "));
	// println("")

	g_RanksSorted = Object.keys(g_Ranks).sort((a,b) => g_Ranks[a].scorePerTimeRatio < g_Ranks[b].scorePerTimeRatio);

	for (let rank of g_RanksSorted)
		println([rank, g_Ranks[rank].scoreRatio, g_Ranks[rank].scorePerTimeRatio, g_Ranks[rank].timeLastKillRatio, g_Ranks[rank].gameTimeRatio].join(" "));
	println("")

	let players = g_RanksSorted.slice();
	let ret = [];
	let scorePerTimeRatioTeam = Array(2).fill(0);

	let teamNum = 2;
	let playerNum = 8;
	let playerNumPT = Math.floor(playerNum/teamNum);
	let getTeam = i => Math.floor(i/playerNumPT);

	for (let i = 0; i < 8; ++i)
	{
		let r = Math.floor((Math.random() * (players.length-1)));
		warn(r)
		let name = players.splice(r, 1)[0];
		ret.push(Object.assign({"name":name}, g_Ranks[name]));
		scorePerTimeRatioTeam[getTeam(i)] += ret[i].scorePerTimeRatio;
	}

	/** 
	 * Random number in range of 0 .. range.
	 * @param {Integer} range
	 */
	let randNumber = range => Math.floor((Math.random() * range));

warn("ee")
	/** 
	 // * Return object with number of random picked attributes
	 * Return array with random picked attributes.
	 * @param {Object} obj
	 * @param {Integer} num - Amount of random picked attributes
	 // * @param {Object} return -
	 * @param {Array} return - 
	 */
	let pickRandomAtts = (obj, num) => {

		let atts = Object.keys(obj);

		return Array(num > atts.length ? atts.length : num).fill("").map(att => 
			atts.splice(randNumber(atts.length - 1), 1)[0]
		);
	}

	 players = pickRandomAtts(g_Ranks, 8);

	// let playersTemp = Array(players.length).fill("");

	for (let i = 0; i < players.length; ++i)
	{
		let playerTemp = players[i];
		let playersTemp = players.slice();

		for (let j = 0; j < players.length; ++j)
		{
			if (i == j)
				continue;

			playersTemp[j] = players[j];
		}
	}






	return;

	/**
	 * Reduce attributes of object to desired ones.
	 * @param {Object} object - Original object.
	 * @param {Array} attributes - Attributes to keep in.
	 * @param {Object} return - Object with desired attributes.
	 */
	let attributesReduce = (object, attributes) => attributes.reduce(function(result, item, index, array) {
		result[item] = object[item];
		return result;
	  }, {});
	// ret.map(el => ({name: el.name, scorePerTimeRatio: el.scorePerTimeRatio}))

	// {
	// 	let newObj = {}; for (let a of attributes) newObj[a] = object[a]; return newObj;
	// 	newObj
	// }

	// let mapReduce = (object, attributes) =>
	// {
	// 	let newObj = {}; for (let a of attributes) newObj[a] = object[a]; return newObj;
	// 	newObj
	// }

	let scorePerTimeRatioTeamTarget = scorePerTimeRatioTeam.reduce((a, b) => a + b) / teamNum;


	// let teamPlayers = ret.map(el => attributesReduce(el, ["name", "scorePerTimeRatio"]));
	let teamPlayers = ret.map(el => ({name: el.name, scorePerTimeRatio: el.scorePerTimeRatio}));
	
	
	warn("map " + uneval(teamPlayers));
	
	warn(uneval(scorePerTimeRatioTeam));
	
	warn(uneval(scorePerTimeRatioTeamTarget));


	warn(uneval(Array(8).fill(1).reduce((a,b,i) => { if (typeof a != 'object') a={[Math.floor(i/4)]: a}; a[Math.floor(i/4)] = (a[Math.floor(i/4)] || 0)+b; return a; })));

	/**
	 * Calculate team scores from array of player scores
	 * @param {Array} player Player scores array
	 * @param {Integer} num Number of teams
	 */
	let teamScores = (player, num) => { let playerNum = player.length / num; return player.reduce((a, b, i) => {
		
		let part = Math.floor(i / playerNum);

		if (typeof a != 'object')
		{
			let aT = a;
			a = Array(num).fill(0);
			a[part] = aT;
		}

		a[part] += b;

		return a;
	}).map(a => a / playerNum); };

	let teamScores2 = (player, num) => { let playerNum = player.length / num; return player.reduce((a,b,i) => { let t = Math.floor(i / playerNum); a[t] += b; return a; }, Array(num).fill(0)).map(a => a / playerNum);
	};

	warn(uneval(teamScores(teamPlayers.map(a => a.scorePerTimeRatio), 2)));
	// warn(uneval(teamScores(teamPlayers.map(a => a.scorePerTimeRatio), 1)));
	warn(uneval(teamScores2(teamPlayers.map(a => a.scorePerTimeRatio), 1)));


	// let a = [0];
	// a[1] = 2;
	// warn(uneval(a))


	warn(uneval(['a','b','c'].reduce(function(result, item, index, array) {
		result[index] = item; //a, b, c
		return result;
	  }, Array(3).fill(0))));


	return;


	// warn(uneval(Array(8).fill(1).reduce((a,b,i) => { if (typeof a != 'object') a={[Math.floor(i/4)]: a}; a[Math.floor(i/4)] = (a[Math.floor(i/4)] || 0)+b; return a; }).map(a => a/4)));
	// return;
	
	// warn("map "+uneval(ret.map(el => ["name", "scorePerTimeRatio"].map(att => ({[att]: el[att] })))));
	// warn("map "+uneval(ret));

	let teamPlayersSorted = teamPlayers.slice();
let k= 0;
	for (let i = 0; i < playerNum; ++i)
	for (let j = 0; j < playerNum; ++j)
	{
		if (i == j || getTeam(i) == getTeam(j))
			continue
			k++;

		let scorePerTimeRatioTeamCheck = Array(teamNum);
		let t = teamPlayersSorted[i];
		teamPlayersSorted[i] = teamPlayersSorted[j];
		teamPlayersSorted[j] = t;
		warn(k+ " " + uneval(teamPlayersSorted.map(a=>a.name)) + (teamPlayersSorted.map(a=>a.scorePerTimeRatio)));

		// scorePerTimeRatioTeamCheck[getTeam(i)] = scorePerTimeRatioTeam[getTeam(i)] - teamPlayers[i].scorePerTimeRatio + teamPlayers[j].scorePerTimeRatio;
		// scorePerTimeRatioTeamCheck[getTeam(j)] = scorePerTimeRatioTeam[getTeam(j)] + teamPlayers[i].scorePerTimeRatio - teamPlayers[j].scorePerTimeRatio;
		// // warn ("hee " + Math.abs(scorePerTimeRatioTeamTarget * 2 - scorePerTimeRatioTeamCheck[getTeam(i)] - scorePerTimeRatioTeamCheck[getTeam(j)]) + "  " + Math.abs(scorePerTimeRatioTeamTarget * 2 - scorePerTimeRatioTeam[getTeam(i)] - scorePerTimeRatioTeam[getTeam(j)]));

		// if (Math.abs(scorePerTimeRatioTeamTarget * 2 - scorePerTimeRatioTeamCheck[getTeam(i)] - scorePerTimeRatioTeamCheck[getTeam(j)]) < Math.abs(scorePerTimeRatioTeamTarget * 2 - scorePerTimeRatioTeam[getTeam(i)] - scorePerTimeRatioTeam[getTeam(j)]))
		// {
		// 	warn("swap " + teamPlayers[i].name + " and "+ teamPlayers[j].name);

		// 	let teamPlayersSorted = Object.assign({}, teamPlayers);
		// 	scorePerTimeRatioTeam[getTeam(i)] = scorePerTimeRatioTeamCheck[getTeam(i)];
		// 	scorePerTimeRatioTeam[getTeam(j)] = scorePerTimeRatioTeamCheck[getTeam(j)];
		// } 
	}



	for (let i = 0; i < playerNum; ++i)
	for (let j = 0; j < playerNum; ++j)
	{
		if (i == j || getTeam(i) == getTeam(j))
			continue

		let scorePerTimeRatioTeamCheck = Array(teamNum);

		scorePerTimeRatioTeamCheck[getTeam(i)] = scorePerTimeRatioTeam[getTeam(i)] - teamPlayers[i].scorePerTimeRatio + teamPlayers[j].scorePerTimeRatio;
		scorePerTimeRatioTeamCheck[getTeam(j)] = scorePerTimeRatioTeam[getTeam(j)] + teamPlayers[i].scorePerTimeRatio - teamPlayers[j].scorePerTimeRatio;
		// warn ("hee " + Math.abs(scorePerTimeRatioTeamTarget * 2 - scorePerTimeRatioTeamCheck[getTeam(i)] - scorePerTimeRatioTeamCheck[getTeam(j)]) + "  " + Math.abs(scorePerTimeRatioTeamTarget * 2 - scorePerTimeRatioTeam[getTeam(i)] - scorePerTimeRatioTeam[getTeam(j)]));

		if (Math.abs(scorePerTimeRatioTeamTarget * 2 - scorePerTimeRatioTeamCheck[getTeam(i)] - scorePerTimeRatioTeamCheck[getTeam(j)]) < Math.abs(scorePerTimeRatioTeamTarget * 2 - scorePerTimeRatioTeam[getTeam(i)] - scorePerTimeRatioTeam[getTeam(j)]))
		{
			warn("swap " + teamPlayers[i].name + " and "+ teamPlayers[j].name);

			let t = teamPlayers[i];
			teamPlayers[i] = teamPlayers[j];
			teamPlayers[j] = t;
			scorePerTimeRatioTeam[getTeam(i)] = scorePerTimeRatioTeamCheck[getTeam(i)];
			scorePerTimeRatioTeam[getTeam(j)] = scorePerTimeRatioTeamCheck[getTeam(j)];
		} 
	}

	// warn("map "+uneval(teamPlayers));
	warn("map "+teamPlayers.map(a=>uneval(a)).join("\n"));
	warn(uneval(scorePerTimeRatioTeam));
	warn(uneval(scorePerTimeRatioTeamTarget));
	warn(" ");

	// for (let i = 0; i < teamNum; ++i)
	// for (let j = 0; j < playerNum; ++j)
	// for (let i2 = 0; i2 < teamNum; ++i2)
	// if (i != i2)
	// for (let j2 = 0; j2 < playerNum; ++j2)
	// {
	// 	teamPlayers[i][j].scorePerTimeRatio
	// 	teamPlayers[i2][j2].scorePerTimeRatio
	// }

	for (let i = 0; i < teamNum*playerNum; ++i)
		for (let j = 0; j < teamNum*playerNum; ++j)
		{
			if (i != j)
			{
				teamPlayers[j/teamNum].player[j/teamNum][1];
			}
		}


	let teams = {};

	let o = 0;
	let scorePerTimeRatioSum = 0;
	let scorePerTimeRatioSumRatio = 0; // players scorePerTimeRatio ratio
	for (let i =0 ; i < playerNumPT; ++i)
		for (let j =0 ; j < teamNum; ++j)
		{
			if (!teams[j])
				teams[j] = {"player": {}, "scorePerTimeRatioSum": 0};
			teams[j].player[i] = [ret[o].name, ret[o].scorePerTimeRatio];
			teams[j].scorePerTimeRatioSum += ret[o].scorePerTimeRatio;
			scorePerTimeRatioSum += ret[o].scorePerTimeRatio;
			warn(o++)
		}

	warn(uneval(teams));
	scorePerTimeRatioSumRatio = (scorePerTimeRatioSum/o);

	warn("overall scorePerTimeRatioSum: " + scorePerTimeRatioSum + ", scorePerTimeRatio: " + scorePerTimeRatioSumRatio);



	let teamsRatio = {};
	for (let j = 0; j < teamNum; ++j)
		for (let i =0 ; i < playerNumPT; ++i)
		{
			if (!teamsRatio[j])
				teamsRatio[j] = { "sum": 0, "num": 0, "ratio": 0};
			teamsRatio[j].sum += teams[j].player[i][1];
			teamsRatio[j].num++;
		}
	
	for (let j = 0; j < teamNum; ++j)
		teamsRatio[j].ratio = teamsRatio[j].sum / teamsRatio[j].num;
		
	warn(uneval(teamsRatio));
}

var g_RanksSorted = [];

function updateSelectionTooltip(selected)
{
	Engine.GetGUIObjectByName("replaySelection").tooltip = selected >= 0 ?
	colorizeHotkey("Hit %(hotkey)s for toggle summary", "summary") : "";
}

var g_Glow = 0;
function forumButtonGlow(glow)
{
	// Engine.GetGUIObjectByName("forumButton").caption = setStringTags("Forum's Replays", { "color": glow ? "yellow" : "white" });
	Engine.GetGUIObjectByName("forumButton").sprite = glow ? "StoneButtonUnsGlow" : "StoneButton";
	let s = Engine.GetGUIObjectByName("replaySelection");
	//  warn(uneval(g_Timers.length))
	if (g_Glow)
		clearTimeout(g_Glow);
	g_Glow = setTimeout(() => forumButtonGlow(!glow), glow ? 1 : s.selected > -1 ? 1000 : 8000);
	setNewTimerFunction
}

function forumButton()
{
	Engine.GetGUIObjectByName("forumButton").tooltip = 
		setStringTags("Download", { "color": "yellow"}) + " and " + 
		setStringTags("upload", { "color": "yellow"}) + " zipped game replays on Wildfire Games Replays Forum.\n\n" +
		setStringTags("Tip:", { "color": "yellow"}) + " Watch the path shown at bottom of this page when selecting a replay" +
		" in the list. Go to the path in your file manager and zip the folder and upload to the forum.\n\n" +
		"Or download and extract a zipped replay folder into a new folder in the replays 0.0.23 directory and reload cache.";
}

function callbackSummary(data)
{
	if (data && !!data.startReplay)
		reallyReallyStartVisualReplay(data.startReplay);
	else if (data && !!data.showSummary)
		showSummary(data.showSummary);
}

function showSummary(summary)
{
	Engine.GetGUIObjectByName("replaySelection").selected = summary;
	showReplaySummary();
}

/**
 * Set sprite of the window and size of the window and the window title and close button caption.
 */
function initGUIWindow()
{
	let window = Engine.GetGUIObjectByName("replayWindow");
	window.sprite = g_Dialog ? "ModernDialog" : "ModernWindow";
	window.size = g_Dialog ? "16 24 100%-16 100%-24" : "0 0 100% 100%";
	Engine.GetGUIObjectByName("replayWindowTitle").size = g_Dialog ? "50%-128 -16 50%+128 16" : "50%-128 4 50%+128 36";
	Engine.GetGUIObjectByName("closeButton").caption = g_Dialog ? translate("Back to Lobby") : translate("Main Menu");
	Engine.GetGUIObjectByName("fadeImage").hidden = !g_Dialog;
	if (g_Dialog)
		Engine.GetGUIObjectByName("cancelHotkey").onPress = close; 
}

/**
 * Store the list of replays loaded in C++ in g_Replays.
 * Check timestamp and compatibility and extract g_Playernames, g_MapNames, g_VictoryConditions.
 * Restore selected filters and item.
 * @param replaySelectionData - Currently selected filters and item to be restored after the loading.
 * @param compareFiles - If true, compares files briefly (which might be slow with optical harddrives),
 *                       otherwise blindly trusts the replay cache.
 */
function loadReplays(replaySelectionData, compareFiles)
{
	g_Replays = Engine.GetReplays(compareFiles);
	
	if (!g_Replays)
		return;

	g_Playernames = [];
	for (let replay of g_Replays)
	{
		let nonAIPlayers = 0;

		// Check replay for compatibility
		replay.isCompatible = isReplayCompatible(replay);

		sanitizeGameAttributes(replay.attribs);

		// Extract map names
		if (g_MapNames.indexOf(replay.attribs.settings.Name) == -1 && replay.attribs.settings.Name != "")
			g_MapNames.push(replay.attribs.settings.Name);

		// Extract playernames
		for (let playerData of replay.attribs.settings.PlayerData)
		{
			if (!playerData || playerData.AI)
				continue;

			// Remove rating from nick
			let playername = playerData.Name;
			let ratingStart = playername.indexOf(" (");
			if (ratingStart != -1)
				playername = playername.substr(0, ratingStart);

			if (g_Playernames.indexOf(playername) == -1)
				g_Playernames.push(playername);

			++nonAIPlayers;
		}

		replay.isMultiplayer = nonAIPlayers > 1;

		replay.isRated = nonAIPlayers == 2 &&
			replay.attribs.settings.PlayerData.length == 2 &&
			replay.attribs.settings.RatingEnabled;
		//let playerRatedData = 
		// if (playerData && playerData.length)
		// 	Object.Assign(playerRatedData, playerData);
	}

	g_MapNames.sort();

	// Reload filters (since they depend on g_Replays and its derivatives)
	initFilters(replaySelectionData && replaySelectionData.filters);

	// Restore user selection
	if (replaySelectionData)
	{
		if (replaySelectionData.directory)
			g_SelectedReplayDirectory = replaySelectionData.directory;

		let replaySelection = Engine.GetGUIObjectByName("replaySelection");
		if (replaySelectionData.column)
			replaySelection.selected_column = replaySelectionData.column;
		if (replaySelectionData.columnOrder)
			replaySelection.selected_column_order = replaySelectionData.columnOrder;
	}

	g_ReplaysLoaded = true;
}

/**
 * We may encounter malformed replays.
 */
function sanitizeGameAttributes(attribs)
{
	if (!attribs.settings)
		attribs.settings = {};

	if (!attribs.settings.Size)
		attribs.settings.Size = -1;

	if (!attribs.settings.Name)
		attribs.settings.Name = "";

	if (!attribs.settings.PlayerData)
		attribs.settings.PlayerData = [];

	if (!attribs.settings.PopulationCap)
		attribs.settings.PopulationCap = 300;

	if (!attribs.settings.mapType)
		attribs.settings.mapType = "skirmish";

	// Remove gaia
	if (attribs.settings.PlayerData.length && attribs.settings.PlayerData[0] == null)
		attribs.settings.PlayerData.shift();

	attribs.settings.PlayerData.forEach((pData, index) => {
		if (!pData.Name)
			pData.Name = "";
	});
}

function initHotkeyTooltips()
{
	Engine.GetGUIObjectByName("playersFilter").tooltip =
		translate("Filter replays by typing one or more, partial or complete playernames.") +
		" " + colorizeAutocompleteHotkey();

	Engine.GetGUIObjectByName("deleteReplayButton").tooltip = deleteTooltip();
}

/**
 * Filter g_Replays, fill the GUI list with that data and show the description of the current replay.
 */
function displayReplayList(autoScroll = true)
{
	if (!g_ReplaysLoaded)
		return;

	// Remember previously selected replay
	var replaySelection = Engine.GetGUIObjectByName("replaySelection");
	if (replaySelection.selected != -1)
		g_SelectedReplayDirectory = g_ReplaysFiltered[replaySelection.selected].directory;

	filterReplays();

	var list = g_ReplaysFiltered.map(replay => {
		let works = replay.isCompatible;

		return {
			"directories": replay.directory,
			"months": compatibilityColor(getReplayDateTime(replay), works),
			"popCaps": compatibilityColor(translatePopulationCapacity(replay.attribs.settings.PopulationCap), works),
			"mapNames": compatibilityColor(getReplayMapName(replay), works),
			"mapSizes": compatibilityColor(translateMapSize(replay.attribs.settings.Size), works),
			"durations": compatibilityColor(getReplayDuration(replay), works),
			"playerNames": compatibilityColor(getReplayPlayernames(replay), works)
		};
	});

	if (list.length)
		list = prepareForDropdown(list);

	// Push to GUI
	replaySelection.selected = -1;
	replaySelection.list_months = list.months || [];
	replaySelection.list_players = list.playerNames || [];
	replaySelection.list_mapName = list.mapNames || [];
	replaySelection.list_mapSize = list.mapSizes || [];
	replaySelection.list_popCapacity = list.popCaps || [];
	replaySelection.list_duration = list.durations || [];

	// Change these last, otherwise crash
	replaySelection.list = list.directories || [];
	replaySelection.list_data = list.directories || [];

	replaySelection.auto_scroll = autoScroll;
	replaySelection.selected = replaySelection.list.findIndex(directory => directory == g_SelectedReplayDirectory);

	displayReplayDetails();
}

function println(line)
{
	print(line + "\n");
}


var g_ResourceData = new Resources();


function metaData(i) //, playernames, lockedTeams)
{
	let playernames = ["fpre", "nani"];

	let lockedTeams = true;

	let replay = g_ReplaysFiltered[i];
	delete gAME.Size;
	
	delete gAME.PopulationCap;
	delete gAME.Name;
	delete gAME.Script;
	delete gAME.PlayerData;
	delete gAME.Description;
	delete gAME.Preview;
	delete gAME.Keywords;
	delete gAME.TriggerDifficulty;
	if ("Biome" in gAME && !gAME.Biome)
		delete gAME.Biome
	
	
	let metadata = Engine.GetReplayMetadata(replay.directory);
	if (!metadata)
		return false;
	

	for (let att in gAME)
	{
		if (!att in metadata.mapSettings)
			continue;

		// if (gAME[att].localeCompare(metadata.mapSettings[att]) != 0)
		if ( ""+gAME[att] != ""+metadata.mapSettings[att])
		{
			warn(att + "|" + gAME[att] + "|" + metadata.mapSettings[att] + "|")
			return false;
		}
	}
	
	let playerStates = metadata &&
		metadata.playerStates &&
		metadata.playerStates && metadata.playerStates.map(pState => pState.state);

	// warn(uneval(Object.keys(metadata.playerStates[0])));
	// let index = g_GameData.sim.playerStates[1].sequences.time.length - 1;

	// let player = 2;

	for (let player in metadata.playerStates)
	{
		let state = metadata.playerStates[player];
		let seqs = state.sequences;
		if (!seqs)
			continue;

		// if (state.lockedTeams != lockedTeams)
		// 	continue;

		let lastVal = 0;
		let lastI = 0;
		for (let i in seqs.enemyUnitsKilledValue)
		{
			if (lastVal != seqs.enemyUnitsKilledValue[i])
			{
				lastVal = seqs.enemyUnitsKilledValue[i];
				lastI = i;
			}
		}

		let time = seqs.time.length;
		if (lastI == 0 || lastI < time*0.66)
			continue;
		let score = lastI < time*0.66 ? 0 : calculateScoreTotal(metadata.playerStates[player], lastI);
		let scorePerTime = lastI == 0 ? 0 : score/lastI;

		let nick = splitRatingFromNick(metadata.playerStates[player].name).nick;

		if (!g_Ranks[nick])
			g_Ranks[nick] = { "scorePerTimeSum": 0, "gameNum": 0, "scoreSum": 0, "timeLastKillSum": 0, "gameTimeSum": 0 };
		let rank = g_Ranks[nick];
		rank.scorePerTimeSum += scorePerTime;
		rank.scoreSum += score;
		rank.timeLastKillSum += lastI;
		rank.gameTimeSum += time;
		++rank.gameNum;

		// println(uneval(seqs.enemyUnitsKilledValue));
	}

	// showVar(metadata.timeElapsed, "value");
	// showVar(metadata.mapSettings, "keys");


	// showVar(metadata.playerStates[1].teamsLocked, "value");
	// println(Object.keys(metadata.playerStates[1].teamsLocked));
	// println(metadata.playerStates.map(pState => pState.state)

	// g_Replays.filter(replay => { let metadata = Engine.GetReplayMetadata(replay.directory); if (!metadata) return false; 
	// 	let seqs = metadata.playerStates[player].sequences;
	
	// });

	//println(uneval(replay.attribs.settings.PlayerData)); //.map(player => player.Name)));

}

var g_Ranks = {};


function showVar(v, keys)
{
	if (keys == "keys")
		println(Object.keys(v).sort());
	else
		println(v);
}

function playerData()
{
	let replay = g_Replays[2];
	
	warn(uneval(Object.keys(replay.attribs.settings.PlayerData[0])));
}


function wonsLost2()
{
	let searchForPlayers = [ "faction02", "Unknown_Player", "Aristol", "Emperior", "darkcity", "TYLER1", "Ricsand", "r4pt0r" ];

	let resultRanks = [];
	const minimumReplayDurationMinutes = 10;




	let replay = g_Replays[42];

	let metadata = Engine.GetReplayMetadata(replay.directory);




	for (let searchForPlayer of searchForPlayers)
	{
		let won = 0
		let wonGameRating = 0; // game rating of won games
		let lostGameRating = 0; // game rating of won games
		let lost = 0;
		let overallGameRating = 0;
		let gamesPlayed = 0;

		for (let i in g_Replays)
		{
			// Var for counting lost players per team
			let teamLosts = [];
			let teamId = -2;
			let teamResult = "";
			let playerRatingsSum = 0;

			let replay = g_Replays[i];
			if (Math.floor(replay.duration/60)<minimumReplayDurationMinutes)
				continue;

			let metadata = Engine.GetReplayMetadata(replay.directory);
			let playerStates = metadata &&
				metadata.playerStates &&
				metadata.playerStates && metadata.playerStates.map(pState => pState.state);
				
			if (!playerStates)
				continue
			
			if (!replay.attribs.settings.LockTeams)
				continue;

			for (let playerData of replay.attribs.settings.PlayerData)
			{
				playerRatingsSum += splitRatingFromNick(playerData.Name).rating ? splitRatingFromNick(playerData.Name).rating : 1200;

				if (!resultRanks[searchForPlayer]) 
					resultRanks[searchForPlayer] = [];

				resultRanks[searchForPlayer].push()
			}
		}
	}
}






function wonsLost()
{
	// metaData()
	// playerData()
	return;
	let searchForPlayers = [ "faction02", "Unknown_Player", "Aristol", "Emperior", "darkcity", "TYLER1", "Ricsand", "r4pt0r" ]
	let resultRanks = [];
	const minimumReplayDurationMinutes = 10;
	for (let searchForPlayer of searchForPlayers)
	{
		let won = 0
		let wonGameRating = 0; // game rating of won games
		let lostGameRating = 0; // game rating of won games
		let lost = 0;
		let overallGameRating = 0;
		let gamesPlayed = 0;

		for (let i in g_Replays)
		{
			// Var for counting lost players per team
			let teamLosts = [];
			let teamId = -2;
			let teamResult = "";
			let playerRatingsSum = 0;

			let replay = g_Replays[i];
			if (Math.floor(replay.duration/60)<minimumReplayDurationMinutes)
				continue;

			let metadata = Engine.GetReplayMetadata(replay.directory);
			let playerStates = metadata &&
				metadata.playerStates &&
				metadata.playerStates && metadata.playerStates.map(pState => pState.state);
				
			if (!playerStates)
				continue
			
			if (!replay.attribs.settings.LockTeams)
				continue;

			for (let playerData of replay.attribs.settings.PlayerData)
			{
				playerRatingsSum += splitRatingFromNick(playerData.Name).rating ? splitRatingFromNick(playerData.Name).rating : 1200;

				if (!resultRanks[searchForPlayer]) 
					resultRanks[searchForPlayer] = [];

				resultRanks[searchForPlayer].push()
			}
		}
	}
}




function wonsLostN()
{
	let searchForPlayers = [ "faction02", "Unknown_Player", "Aristol", "Emperior", "darkcity", "TYLER1", "Ricsand", "r4pt0r" ]
	let resultRanks = [];
	const minimumReplayDurationMinutes = 10;
	for (let searchForPlayer of searchForPlayers)
	{
	let won = 0
	let wonGameRating = 0; // game rating of won games
	let lostGameRating = 0; // game rating of won games
	let lost = 0;
	let overallGameRating = 0;
	let gamesPlayed = 0;

	for (let i in g_Replays)
	{
		// Var for counting lost players per team
		let teamLosts = [];
		let teamId = -2;
		let teamResult = "";
		let playerRatingsSum = 0;

		let replay = g_Replays[i];
		if (Math.floor(replay.duration/60)<minimumReplayDurationMinutes)
			continue;

		let metadata = Engine.GetReplayMetadata(replay.directory);
		let playerStates = metadata &&
		metadata.playerStates &&
		metadata.playerStates && metadata.playerStates.map(pState => pState.state);

		let playerIdx = 0;
		// if (replay.attribs.settings.PlayerData.length <= 2 ||)
		// 	continue
		if (!replay.attribs.settings.LockTeams)
			continue;
			// warn(uneval(replay.attribs.settings.PlayerData))
		for (let playerData of replay.attribs.settings.PlayerData)
		{
			++playerIdx;
			
			// if (splitRatingFromNick(playerData.Name).nick != "Emperior" || !playerStates)
			if (!playerStates)
				continue
			
			// warn(splitRatingFromNick(playerData.Name).rating ? "" : 1200)
			playerRatingsSum += splitRatingFromNick(playerData.Name).rating ? splitRatingFromNick(playerData.Name).rating : 1200;

			if (!teamResult && splitRatingFromNick(playerData.Name).nick == searchForPlayer)
			{
				teamId = +playerData.Team;
				if (playerStates[playerIdx] == "defeated")
				{
					teamResult = "defeated";
					// ++lost;
					// break;
				}
				else if (playerStates[playerIdx] == "won")
				{
					teamResult = "won";
					// ++won;
					// break;
				}
				// else
				// 	teamId = playerData.Team;
			}

			if (playerStates[playerIdx] == "defeated")
				if (!teamLosts[playerData.Team])
					teamLosts[+playerData.Team] = 1;
				else
					++teamLosts[+playerData.Team];
				// teamLosts[playerData.Team] = teamLosts[playerData.Team] ? teamLosts[playerData.Team] + 1 : 1;

			// if (playerStates[playerIdx] == "won")
			// 	++won;
			// if (playerStates[playerIdx] == "defeated")
			// 	++lost;

			// warn(splitRatingFromNick(playerData.Name).nick + " " + (playerStates ? playerStates[playerIdx] : "")) // ==
		}
		// player not in replay
		if (teamId == -2)
			continue;

		let gameRating = Math.round(playerRatingsSum / playerIdx)
		overallGameRating += gameRating;
		++gamesPlayed;

		if (!teamResult)
		{
			if (!teamLosts[teamId])
				teamResult = "won";
			else
				if (teamLosts.filter(team => team != teamId).every(losts => losts >= teamLosts[teamId]))
					teamResult = "won";
				else
					teamResult = "defeated";
		}

		if (teamResult == "won")
		{
			++won;
			wonGameRating += gameRating;
		}
		else if (teamResult == "defeated")
		{
			++lost;
			lostGameRating += gameRating;
		}
	}
	let wonRatio = (won/(won+lost));
	let lostRatio = (lost/(won+lost));
	let wonper = Math.round(wonRatio*100);
	let overallGameRatingAverage = Math.round(overallGameRating/gamesPlayed);
	// warn(searchForPlayer + " winper: " + wonper + "% won: " + won + " losts:" + lost + " games played: " + gamesPlayed + " game rating: " + overallGameRatingAverage + " rank: " + (wonper*(overallGameRatingAverage/1200))); //*(gamesPlayed/5));
	let rank = (wonper*(overallGameRatingAverage/1200));
	resultRanks.push({ "name": searchForPlayer, "rank": rank, "winper": wonper, "gamesPlayed": gamesPlayed, "gameRating": overallGameRatingAverage, "wonGameRating": Math.round(wonRatio*(wonGameRating/won)), "lostGameRating": lost ? Math.round((lostGameRating/lost)) : 0 })

	// overall rank:
	//               overallGameRatingAverage / 1200
	//               *
	//               won percentage
	}
	warn("\n" + resultRanks.sort((B,A) => A.wonGameRating-B.wonGameRating).map(pl => "name: " + pl.name + " rank: " + pl.rank + " (winper: " + pl.winper + " gamesPlayed: " + pl.gamesPlayed + " gameRating: " + pl.gameRating + " wonGameRating: " + pl.wonGameRating + " lostGameRating: " + pl.lostGameRating + ")").join("\n"));
}

/**
 * Shows preview image, description and player text in the right panel.
 */
function displayReplayDetails()
{
	let selected = Engine.GetGUIObjectByName("replaySelection").selected;
	let replaySelected = selected > -1;

	Engine.GetGUIObjectByName("replayInfo").hidden = !replaySelected;
	Engine.GetGUIObjectByName("replayInfoEmpty").hidden = replaySelected;
	Engine.GetGUIObjectByName("startReplayButton").enabled = replaySelected;
	Engine.GetGUIObjectByName("deleteReplayButton").enabled = replaySelected;
	Engine.GetGUIObjectByName("replayFilename").hidden = !replaySelected;
	Engine.GetGUIObjectByName("summaryButton").hidden = true;

	if (!replaySelected)
		return;

	let replay = g_ReplaysFiltered[selected];

	Engine.GetGUIObjectByName("sgMapName").caption = translate(replay.attribs.settings.Name);
	Engine.GetGUIObjectByName("sgMapSize").caption = translateMapSize(replay.attribs.settings.Size);
	Engine.GetGUIObjectByName("sgMapType").caption = translateMapType(replay.attribs.settings.mapType);
	Engine.GetGUIObjectByName("sgVictory").caption = replay.attribs.settings.VictoryConditions.map(victoryConditionName =>
		translateVictoryCondition(victoryConditionName)).join(translate(", "));
	Engine.GetGUIObjectByName("sgNbPlayers").caption = sprintf(translate("Players: %(numberOfPlayers)s"),
		{ "numberOfPlayers": replay.attribs.settings.PlayerData.length });
	Engine.GetGUIObjectByName("replayFilename").caption = Engine.GetReplayDirectoryName(replay.directory);

	let metadata = Engine.GetReplayMetadata(replay.directory);
	Engine.GetGUIObjectByName("sgPlayersNames").caption =
		formatPlayerInfo(
			replay.attribs.settings.PlayerData,
			Engine.GetGUIObjectByName("showSpoiler").checked &&
				metadata &&
				metadata.playerStates &&
				metadata.playerStates.map(pState => pState.state)
		);

	let mapData = getMapDescriptionAndPreview(replay.attribs.settings.mapType, replay.attribs.map, replay.attribs);
	Engine.GetGUIObjectByName("sgMapDescription").caption = mapData.description;

	Engine.GetGUIObjectByName("summaryButton").hidden = !Engine.HasReplayMetadata(replay.directory);

	setMapPreviewImage("sgMapPreview", mapData.preview);
}

/**
 * Returns a human-readable version of the replay date.
 */
function getReplayDateTime(replay)
{
	return Engine.FormatMillisecondsIntoDateStringLocal(replay.attribs.timestamp * 1000, translate("yyyy-MM-dd HH:mm"));
}

/**
 * Returns a human-readable list of the playernames of that replay.
 *
 * @returns {string}
 */
function getReplayPlayernames(replay)
{
	return replay.attribs.settings.PlayerData.map(pData => pData.Name).join(", ");
}

/**
 * Returns the name of the map of the given replay.
 *
 * @returns {string}
 */
function getReplayMapName(replay)
{
	return translate(replay.attribs.settings.Name);
}

/**
 * Returns the month of the given replay in the format "yyyy-MM".
 *
 * @returns {string}
 */
function getReplayMonth(replay)
{
	return Engine.FormatMillisecondsIntoDateStringLocal(replay.attribs.timestamp * 1000, translate("yyyy-MM"));
}

/**
 * Returns a human-readable version of the time when the replay started.
 *
 * @returns {string}
 */
function getReplayDuration(replay)
{
	return timeToString(replay.duration * 1000);
}

/**
 * True if we can start the given replay with the currently loaded mods.
 */
function isReplayCompatible(replay)
{
	return replayHasSameEngineVersion(replay) && hasSameMods(replay.attribs.mods, g_EngineInfo.mods);
}

/**
 * True if we can start the given replay with the currently loaded mods.
 */
function replayHasSameEngineVersion(replay)
{
	return replay.attribs.engine_version && replay.attribs.engine_version == g_EngineInfo.engine_version;
}