
/**
 * Function copied and small changed from original source
 */
selectPanel = function(panel)
{
	// TODO: move panel buttons to a custom parent object
	for (let button of Engine.GetGUIObjectByName("summaryWindow").children)
		if (button.name.endsWith("PanelButton"))
			button.sprite = "ModernTabHorizontalBackground";

	panel.sprite = "ModernTabHorizontalForeground";

	adjustTabDividers(panel.size);
	let openedPanel = panel.name.substr(0, panel.name.length - "PanelButton".length);

	let generalPanel = Engine.GetGUIObjectByName("generalPanel");
	let chartsPanel = Engine.GetGUIObjectByName("chartsPanel");
	let chartsHidden = panel.name != "chartsPanelButton";
	generalPanel.hidden = !chartsHidden;
	chartsPanel.hidden = chartsHidden;
	if (chartsHidden)
		updatePanelData(g_ScorePanelsData[panel.name.substr(0, panel.name.length - "PanelButton".length)], openedPanel);
	else
	{
		[0, 1].forEach(updateCategoryDropdown);
	}

	g_SelectedPanel = panel.name;
}

// const updateCountersPlayer_fg = updateCountersPlayer;

/**
 * New Function for showing techs icons
 */
function updateTechsPlayer(playerState, counters, headings, idGUI, index)
{
    let fn = counters[0].fn; // total count
    Engine.GetGUIObjectByName(idGUI + "[" + 0 + "]").caption =
        formatSummaryValue(fn && fn(playerState, index, headings[+0 + 1].identifier));
    Engine.GetGUIObjectByName(idGUI + "[" + 1 + "]").caption = "";

    let techsIdGUI = idGUI.replace("valueData", "valueDataTechs");

	let i = -1;
	let left = 340;
	// warn(uneval(counters[1].fn))
	// warn(uneval(Object.keys(g_ParsedData[playerState.civ][0].name.internal)));
	// warn(uneval(g_ParsedData[playerState.civ][0].name.internal));

	let techs = counters[1].fn(playerState, index, headings[+0 + 1].identifier);
// warn(uneval(Engine.GetGUIObjectByName("dataB[1]").getComputedSize()))
	let space = Engine.GetGUIObjectByName("dataB[1]").getComputedSize().right;

    for (let tech of techs)
    {
		++i;
		// warn(left + " " + space + " " +i)
		if (left > space-90 || i>140-1) // 140 icons hardcode per player in xml available
			break;
        // warn(tech) 
        // warn(TechnologyTemplates.Get(tech))
        
        // loadTechnology(tech)

		let icon = Engine.GetGUIObjectByName(techsIdGUI + "[" + i + "]");
		let techData = g_ParsedData[playerState.civ].find(techs => techs.name.internal == tech);
		if (!techData)
		{
			continue;
		}
		icon.sprite = "stretched:session/portraits/" + techData.icon;
		icon.tooltip = techData.name.generic + "\n" + techData.tooltip;
		
		icon.hidden = false;
		// if (g_PlayersHighestTechCount > 32)
		// {
		// 	warn("ok")
		// 	let size = 16;
		// 	let pad = 3;
		// 	let ystart = pad;
		// 	if (i%2==1)
		// 		ystart+=size+pad;
		// 	icon.size = pad+"+"+left+" "+ystart+" "+pad+"+"+size+"+"+left+" "+ystart+"+"+size;
		// 	if (i%2==1)
		// 		left+=size+pad;
		// }
		// else
		// {
			let size = 32;
			let pad = 4;
			let ystart = pad;
		
			icon.size = pad+"+"+left+" "+ystart+" "+pad+"+"+size+"+"+left+" "+ystart+"+"+size;
	
			left+=size+pad;
		// }
    }
}

var g_ResetGeneralPanel = resetGeneralPanel;
resetGeneralPanel = function()
{
	if (false)
	for (let h = 0; h < 26; ++h)
	{
		for (let p = 0; p < g_MaxPlayers; ++p)
		{
			Engine.GetGUIObjectByName("valueDataTechs[" + p + "][" + h + "]").hidden = true;
			for (let t = 0; t < g_MaxTeams; ++t)
			{
				Engine.GetGUIObjectByName("valueDataTechsTeam[" + t + "][" + p + "][" + h + "]").hidden = true;
				Engine.GetGUIObjectByName("valueDataTechsTeam[" + t + "][" + h + "]").hidden = true;
			}
		}
	}
	g_ResetGeneralPanel();
}

// const updatePanelData_fg = updatePanelData;
var g_PlayersHighestTechCount = 0

/**
 * Function copied and small changed for techs from original source
 */
updatePanelData = function(panelInfo, panelName)
{
	resetGeneralPanel();
	updateGeneralPanelHeadings(panelInfo.headings);
	updateGeneralPanelTitles(panelInfo.titleHeadings);
	let rowPlayerObjectWidth = updateGeneralPanelCounter(panelInfo.counters);
	updateGeneralPanelTeams();

	let index = g_GameData.sim.playerStates[1].sequences.time.length - 1;
	let playerBoxesCounts = [];

	g_PlayersHighestTechCount = 0;
	if (panelName == "techs")
		for (let i = 1; i <= g_PlayerCount; ++i)
		{
			let playerState = g_GameData.sim.playerStates[i];			
			let num = calculateTechsTotal(playerState, index, "total");
			if (num > g_PlayersHighestTechCount)
				g_PlayersHighestTechCount = num;
		}

	// warn(g_PlayersHighestTechCount)

	for (let i = 0; i < g_PlayerCount; ++i)
	{
		let playerState = g_GameData.sim.playerStates[i + 1];

		if (!playerBoxesCounts[playerState.team + 1])
			playerBoxesCounts[playerState.team + 1] = 1;
		else
			playerBoxesCounts[playerState.team + 1] += 1;

		let positionObject = playerBoxesCounts[playerState.team + 1] - 1;
		let rowPlayer = "playerBox[" + positionObject + "]";
		let playerOutcome = "playerOutcome[" + positionObject + "]";
		let playerNameColumn = "playerName[" + positionObject + "]";
		let playerCivicBoxColumn = "civIcon[" + positionObject + "]";
		let playerCounterValue = "valueData[" + positionObject + "]";

		if (playerState.team != -1)
		{
			rowPlayer = "playerBoxt[" + playerState.team + "][" + positionObject + "]";
			playerOutcome = "playerOutcomet[" + playerState.team + "][" + positionObject + "]";
			playerNameColumn = "playerNamet[" + playerState.team + "][" + positionObject + "]";
			playerCivicBoxColumn = "civIcont[" + playerState.team + "][" + positionObject + "]";
			playerCounterValue = "valueDataTeam[" + playerState.team + "][" + positionObject + "]";
		}

		let colorString = "color: " +
			Math.floor(playerState.color.r * 255) + " " +
			Math.floor(playerState.color.g * 255) + " " +
			Math.floor(playerState.color.b * 255);

		let rowPlayerObject = Engine.GetGUIObjectByName(rowPlayer);
		rowPlayerObject.hidden = false;
		rowPlayerObject.sprite = colorString + " " + g_PlayerBoxAlpha;

		let boxSize = rowPlayerObject.size;
		boxSize.right = rowPlayerObjectWidth;
		rowPlayerObject.size = boxSize;
		// warn(uneval(rowPlayerObject.getComputedSize()));
		// warn(uneval(boxSize));

		setOutcomeIcon(playerState.state, playerOutcome);

		playerNameColumn = Engine.GetGUIObjectByName(playerNameColumn);
		playerNameColumn.caption = g_GameData.sim.playerStates[i + 1].name;
		playerNameColumn.tooltip = translateAISettings(g_GameData.sim.mapSettings.PlayerData[i + 1]);

		let civIcon = Engine.GetGUIObjectByName(playerCivicBoxColumn);
		civIcon.sprite = "stretched:" + g_CivData[playerState.civ].Emblem;
		civIcon.tooltip = 
			g_CivData[playerState.civ].Name + " Structure Tree " + setStringTags("\\[Click]", g_HotkeyTags);
		civIcon.onPress = (civ => function() { showCivGui(civ); })(playerState.civ);

		let updateFunc = panelName == "techs" ? updateTechsPlayer: updateCountersPlayer;
		
		updateFunc(playerState, panelInfo.counters, panelInfo.headings, playerCounterValue, index);
	}

	let teamCounterFn = panelInfo.teamCounterFn;
	if (g_Teams && teamCounterFn)
		updateCountersTeam(teamCounterFn, panelInfo.counters, panelInfo.headings, index);
}